LibreOffice: XStorage Interface Reference

LibreOffice LibreOffice 7.4 SDK API Reference

Loading...
Searching...
No Matches
Exported Interfaces | Public Member Functions | List of all members
XStorage Interface Referencepublished

This interface represents main storage functionality. More...

Inheritance diagram for XStorage:

## Exported Interfaces
interface | ::com::sun::star::container::XNameAccess
| allows to get list of child elements and to check if an element with a specified name exists in a storage.
interface | ::com::sun::star::lang::XComponent
| allows to control and track lifetime of the storage.

## Public Member Functions
void | copyToStorage ([in] XStorage xDest) raises ( ::com::sun::star::embed::InvalidStorageException, ::com::sun::star::lang::IllegalArgumentException, ::com::sun::star::io::IOException, ::com::sun::star::embed::StorageWrappedTargetException )
| allows to copy current storage to another one
::com::sun::star::io::XStream | openStreamElement ([in] string sStreamName, [in] long nOpenMode) raises ( ::com::sun::star::embed::InvalidStorageException, ::com::sun::star::lang::IllegalArgumentException, ::com::sun::star::packages::WrongPasswordException, ::com::sun::star::io::IOException, ::com::sun::star::embed::StorageWrappedTargetException )
| allows to get access to a child stream of the storage.
::com::sun::star::io::XStream | openEncryptedStreamElement ([in] string sStreamName, [in] long nOpenMode, [in] string sPassword) raises ( ::com::sun::star::embed::InvalidStorageException, ::com::sun::star::lang::IllegalArgumentException, ::com::sun::star::packages::NoEncryptionException, ::com::sun::star::packages::WrongPasswordException, ::com::sun::star::io::IOException, ::com::sun::star::embed::StorageWrappedTargetException )
| allows to get access to a child encrypted stream with password.
XStorage | openStorageElement ([in] string sStorName, [in] long nOpenMode) raises ( ::com::sun::star::embed::InvalidStorageException, ::com::sun::star::lang::IllegalArgumentException, ::com::sun::star::io::IOException, ::com::sun::star::embed::StorageWrappedTargetException )
| allows to get access to a child storage.
::com::sun::star::io::XStream | cloneStreamElement ([in] string sStreamName) raises ( ::com::sun::star::embed::InvalidStorageException, ::com::sun::star::lang::IllegalArgumentException, ::com::sun::star::packages::WrongPasswordException, ::com::sun::star::io::IOException, ::com::sun::star::embed::StorageWrappedTargetException )
| allows to get readonly copy of a child stream of the storage.
::com::sun::star::io::XStream | cloneEncryptedStreamElement ([in] string sStreamName, [in] string sPassword) raises ( ::com::sun::star::embed::InvalidStorageException, ::com::sun::star::lang::IllegalArgumentException, ::com::sun::star::packages::NoEncryptionException, ::com::sun::star::packages::WrongPasswordException, ::com::sun::star::io::IOException, ::com::sun::star::embed::StorageWrappedTargetException )
| allows to get readonly copy of a child encrypted stream with password.
void | copyLastCommitTo ([in] XStorage xTargetStorage) raises ( ::com::sun::star::embed::InvalidStorageException, ::com::sun::star::lang::IllegalArgumentException, ::com::sun::star::io::IOException, ::com::sun::star::embed::StorageWrappedTargetException )
| allows to get copy of this storage at the state of its last commit.
void | copyStorageElementLastCommitTo ([in] string sStorName, [in] XStorage xTargetStorage) raises ( ::com::sun::star::embed::InvalidStorageException, ::com::sun::star::lang::IllegalArgumentException, ::com::sun::star::io::IOException, ::com::sun::star::embed::StorageWrappedTargetException )
| allows to get copy of a child storage at the state of its last commit.
boolean | isStreamElement ([in] string sElementName) raises ( ::com::sun::star::container::NoSuchElementException, ::com::sun::star::lang::IllegalArgumentException, ::com::sun::star::embed::InvalidStorageException )
| allows to check if an element is a child stream with specified name.
boolean | isStorageElement ([in] string sElementName) raises ( ::com::sun::star::container::NoSuchElementException, ::com::sun::star::lang::IllegalArgumentException, ::com::sun::star::embed::InvalidStorageException )
| allows to check if an element is a child storage with specified name.
void | removeElement ([in] string sElementName) raises ( ::com::sun::star::embed::InvalidStorageException, ::com::sun::star::lang::IllegalArgumentException, ::com::sun::star::container::NoSuchElementException, ::com::sun::star::io::IOException, ::com::sun::star::embed::StorageWrappedTargetException )
| removes an element from a storage.
void | renameElement ([in] string sElementName, [in] string sNewName) raises ( ::com::sun::star::embed::InvalidStorageException, ::com::sun::star::lang::IllegalArgumentException, ::com::sun::star::container::NoSuchElementException, ::com::sun::star::container::ElementExistException, ::com::sun::star::io::IOException, ::com::sun::star::embed::StorageWrappedTargetException )
| renames an element in a storage.
void | copyElementTo ([in] string sElementName, [in] XStorage xDest, [in] string sNewName) raises ( ::com::sun::star::embed::InvalidStorageException, ::com::sun::star::lang::IllegalArgumentException, ::com::sun::star::container::NoSuchElementException, ::com::sun::star::container::ElementExistException, ::com::sun::star::io::IOException, ::com::sun::star::embed::StorageWrappedTargetException )
| allows to copy an entry from one storage to another.
void | moveElementTo ([in] string sElementName, [in] XStorage xDest, [in] string sNewName) raises ( ::com::sun::star::embed::InvalidStorageException, ::com::sun::star::lang::IllegalArgumentException, ::com::sun::star::container::NoSuchElementException, ::com::sun::star::container::ElementExistException, ::com::sun::star::io::IOException, ::com::sun::star::embed::StorageWrappedTargetException )
| allows to move an entry from one storage to another.
Public Member Functions inherited from XNameAccess
any | getByName ([in] string aName) raises ( com::sun::star::container::NoSuchElementException, com::sun::star::lang::WrappedTargetException )
sequence< string > | getElementNames ()
boolean | hasByName ([in] string aName)
Public Member Functions inherited from XElementAccess
type | getElementType ()
boolean | hasElements ()
Public Member Functions inherited from XInterface
any | queryInterface ([in] type aType)
| queries for a new interface to an existing UNO object.
void | acquire ()
| increases the reference counter by one.
void | release ()
| decreases the reference counter by one.
Public Member Functions inherited from XComponent
void | dispose ()
| The owner of an object calls this method to explicitly free all resources kept by this object and thus break cyclic references.
void | addEventListener ([in] XEventListener xListener)
| adds an event listener to the object.
void | removeEventListener ([in] XEventListener aListener)
| removes an event listener from the listener list.

## Detailed Description

This interface represents main storage functionality.

## Exported Interfaces

## ◆ ::com::sun::star::container::XNameAccess

interface ::com::sun::star::container::XNameAccess

allows to get list of child elements and to check if an element with a specified name exists in a storage.

It is also possible to use this interface to get read access to a child element by com::sun::star::container::XNameAccess::getByName() call. But the recommended way is to use XStorage interface for this purpose.

## ◆ ::com::sun::star::lang::XComponent

interface ::com::sun::star::lang::XComponent

allows to control and track lifetime of the storage.

In case a storage is disposed any call to its methods should result in com::sun::star::lang::DisposedException.

## Member Function Documentation

## ◆ cloneEncryptedStreamElement()

::com::sun::star::io::XStream cloneEncryptedStreamElement | ( | [in] string | sStreamName,
|  | [in] string | sPassword
| ) |  |
raises | ( | ::com::sun::star::embed::InvalidStorageException,
|  | ::com::sun::star::lang::IllegalArgumentException,
|  | ::com::sun::star::packages::NoEncryptionException,
|  | ::com::sun::star::packages::WrongPasswordException,
|  | ::com::sun::star::io::IOException,
|  | ::com::sun::star::embed::StorageWrappedTargetException
| ) |  |

allows to get readonly copy of a child encrypted stream with password.

If storage does not allow any encryption this method will always throw com::sun::star::packages::NoEncryptionException.

The stream is open in readonly mode so the com::sun::star::io::XStream::getOutputStream() method will return an empty reference.

This method allows to specify reading password for the child stream explicitly.

Parameters

  sStreamName | the name of the substream that should be copied
  sPassword | this parameter allows to specify a reading password for the stream, the password must be a correct one, otherwise an exception will be thrown

Exceptions

  com::sun::star::embed::InvalidStorageException | this storage is in invalid state for any reason
  com::sun::star::lang::IllegalArgumentException | one of provided arguments is illegal
  com::sun::star::packages::NoEncryptionException | the stream is not encrypted
  com::sun::star::packages::WrongPasswordException | the provided password is wrong
  com::sun::star::io::IOException | in case of io errors during stream opening
  com::sun::star::embed::StorageWrappedTargetException | wraps other exceptions

## ◆ cloneStreamElement()

::com::sun::star::io::XStream cloneStreamElement | ( | [in] string | sStreamName | ) |
raises | ( | ::com::sun::star::embed::InvalidStorageException,
|  | ::com::sun::star::lang::IllegalArgumentException,
|  | ::com::sun::star::packages::WrongPasswordException,
|  | ::com::sun::star::io::IOException,
|  | ::com::sun::star::embed::StorageWrappedTargetException
| ) |  |

allows to get readonly copy of a child stream of the storage.

The stream is open in readonly mode so the com::sun::star::io::XStream::getOutputStream() method will return an empty reference.

Parameters

  sStreamName | the name of the substream that should be copied

Exceptions

  com::sun::star::embed::InvalidStorageException | this storage is in invalid state for any reason
  com::sun::star::lang::IllegalArgumentException | one of provided arguments is illegal
  com::sun::star::packages::WrongPasswordException | the provided password is wrong
  com::sun::star::io::IOException | in case of io errors during stream opening
  com::sun::star::embed::StorageWrappedTargetException | wraps other exceptions

## ◆ copyElementTo()

void copyElementTo | ( | [in] string | sElementName,
|  | [in] XStorage | xDest,
|  | [in] string | sNewName
| ) |  |
raises | ( | ::com::sun::star::embed::InvalidStorageException,
|  | ::com::sun::star::lang::IllegalArgumentException,
|  | ::com::sun::star::container::NoSuchElementException,
|  | ::com::sun::star::container::ElementExistException,
|  | ::com::sun::star::io::IOException,
|  | ::com::sun::star::embed::StorageWrappedTargetException
| ) |  |

allows to copy an entry from one storage to another.

If target element supports transacted mode it must be committed by this method after successful copying.

Parameters

  sElementName | the name of the element in this storage
  xDest | a destination storage
  sNewName | the name of the result element in destination storage

Exceptions

  com::sun::star::embed::InvalidStorageException | this storage is in invalid state for any reason
  com::sun::star::container::NoSuchElementException | there is no specified source element in this storage
  com::sun::star::container::ElementExistException | an element with specified destination name already exists in destination storage
  com::sun::star::io::IOException | in case of io errors during copying
  com::sun::star::embed::StorageWrappedTargetException | wraps other exceptions

## ◆ copyLastCommitTo()

void copyLastCommitTo | ( | [in] XStorage | xTargetStorage | ) |
raises | ( | ::com::sun::star::embed::InvalidStorageException,
|  | ::com::sun::star::lang::IllegalArgumentException,
|  | ::com::sun::star::io::IOException,
|  | ::com::sun::star::embed::StorageWrappedTargetException
| ) |  |

allows to get copy of this storage at the state of its last commit.

This method makes sense only for services implementations that allow transaction in the storage.

Parameters

  xTargetStorage | the target storage that will be filled in with copy.

Exceptions

  com::sun::star::embed::InvalidStorageException | this storage is in invalid state for any reason
  com::sun::star::lang::IllegalArgumentException | one of provided arguments is illegal
  com::sun::star::io::IOException | in case of io errors during copying
  com::sun::star::embed::StorageWrappedTargetException | wraps other exceptions

## ◆ copyStorageElementLastCommitTo()

void copyStorageElementLastCommitTo | ( | [in] string | sStorName,
|  | [in] XStorage | xTargetStorage
| ) |  |
raises | ( | ::com::sun::star::embed::InvalidStorageException,
|  | ::com::sun::star::lang::IllegalArgumentException,
|  | ::com::sun::star::io::IOException,
|  | ::com::sun::star::embed::StorageWrappedTargetException
| ) |  |

allows to get copy of a child storage at the state of its last commit.

This method makes sense only for services implementations that allow transaction in the storage.

Parameters

  sStorName | the name of the storage that should be copied
  xTargetStorage | the target storage that will be filled in with copy

Exceptions

  com::sun::star::embed::InvalidStorageException | this storage is in invalid state for any reason
  com::sun::star::lang::IllegalArgumentException | one of provided arguments is illegal
  com::sun::star::io::IOException | in case of io errors during copying
  com::sun::star::embed::StorageWrappedTargetException | wraps other exceptions

## ◆ copyToStorage()

void copyToStorage | ( | [in] XStorage | xDest | ) |
raises | ( | ::com::sun::star::embed::InvalidStorageException,
|  | ::com::sun::star::lang::IllegalArgumentException,
|  | ::com::sun::star::io::IOException,
|  | ::com::sun::star::embed::StorageWrappedTargetException
| ) |  |

allows to copy current storage to another one

The destination storage contents are overwritten. After the successful copying the target storage is automatically committed if it implements transacted access.

Parameters

  xDest | a destination storage this storage must be copied to.

Exceptions

  com::sun::star::embed::InvalidStorageException | this storage is in invalid state for any reason
  com::sun::star::lang::IllegalArgumentException | an illegal argument is provided
  com::sun::star::io::IOException | in case of io errors during copying
  com::sun::star::embed::StorageWrappedTargetException | wraps other exception acquired during copying

## ◆ isStorageElement()

boolean isStorageElement | ( | [in] string | sElementName | ) |
raises | ( | ::com::sun::star::container::NoSuchElementException,
|  | ::com::sun::star::lang::IllegalArgumentException,
|  | ::com::sun::star::embed::InvalidStorageException
| ) |  |

allows to check if an element is a child storage with specified name.

In case there is no child element with such name an exception will be thrown.

Parameters

  sElementName | the name of the element to check

Returns
  `TRUE` in case the element is a storage `FALSE` - the element is a stream

Exceptions

  com::sun::star::container::NoSuchElementException | there is no element with such name
  com::sun::star::lang::IllegalArgumentException | an illegal argument is provided
  com::sun::star::embed::InvalidStorageException | this storage is in invalid state for any reason

## ◆ isStreamElement()

boolean isStreamElement | ( | [in] string | sElementName | ) |
raises | ( | ::com::sun::star::container::NoSuchElementException,
|  | ::com::sun::star::lang::IllegalArgumentException,
|  | ::com::sun::star::embed::InvalidStorageException
| ) |  |

allows to check if an element is a child stream with specified name.

In case there is no child element with such name an exception will be thrown.

Parameters

  sElementName | the name of the element to check

Returns
  `TRUE` in case the element is a stream `FALSE` - the element is a storage

Exceptions

  com::sun::star::container::NoSuchElementException | there is no element with such name
  com::sun::star::lang::IllegalArgumentException | an illegal argument is provided
  com::sun::star::embed::InvalidStorageException | this storage is in invalid state for any reason

## ◆ moveElementTo()

void moveElementTo | ( | [in] string | sElementName,
|  | [in] XStorage | xDest,
|  | [in] string | sNewName
| ) |  |
raises | ( | ::com::sun::star::embed::InvalidStorageException,
|  | ::com::sun::star::lang::IllegalArgumentException,
|  | ::com::sun::star::container::NoSuchElementException,
|  | ::com::sun::star::container::ElementExistException,
|  | ::com::sun::star::io::IOException,
|  | ::com::sun::star::embed::StorageWrappedTargetException
| ) |  |

allows to move an entry from one storage to another.

If target element supports transacted mode it must be committed by this method after successful moving.

Parameters

  sElementName | the name of the element in this storage
  xDest | a destination storage
  sNewName | the name of the result element in destination storage

Exceptions

  com::sun::star::embed::InvalidStorageException | this storage is in invalid state for any reason
  com::sun::star::container::NoSuchElementException | there is no specified source element in this storage
  com::sun::star::container::ElementExistException | an element with specified destination name already exists in destination storage
  com::sun::star::io::IOException | in case of io errors during moving
  com::sun::star::embed::StorageWrappedTargetException | wraps other exceptions

## ◆ openEncryptedStreamElement()

::com::sun::star::io::XStream openEncryptedStreamElement | ( | [in] string | sStreamName,
|  | [in] long | nOpenMode,
|  | [in] string | sPassword
| ) |  |
raises | ( | ::com::sun::star::embed::InvalidStorageException,
|  | ::com::sun::star::lang::IllegalArgumentException,
|  | ::com::sun::star::packages::NoEncryptionException,
|  | ::com::sun::star::packages::WrongPasswordException,
|  | ::com::sun::star::io::IOException,
|  | ::com::sun::star::embed::StorageWrappedTargetException
| ) |  |

allows to get access to a child encrypted stream with password.

If storage does not allow any encryption this method will always throw com::sun::star::packages::NoEncryptionException.

In case the stream is open in readonly mode the com::sun::star::io::XStream::getOutputStream() method will return an empty reference.

Parameters

  sStreamName | the name of the substream that should be open
  nOpenMode | a mode the stream should be open in, can be a combination of ElementModes values
  sPassword | this parameter allows to specify a reading password for the stream, the password must be a correct one, otherwise an exception will be thrown

Exceptions

  com::sun::star::embed::InvalidStorageException | this storage is in invalid state for any reason
  com::sun::star::lang::IllegalArgumentException | one of provided arguments is illegal
  com::sun::star::packages::NoEncryptionException | the stream is not encrypted
  com::sun::star::packages::WrongPasswordException | the provided password is wrong
  com::sun::star::io::IOException | in case of io errors during stream opening
  com::sun::star::embed::StorageWrappedTargetException | wraps other exceptions

## ◆ openStorageElement()

XStorage openStorageElement | ( | [in] string | sStorName,
|  | [in] long | nOpenMode
| ) |  |
raises | ( | ::com::sun::star::embed::InvalidStorageException,
|  | ::com::sun::star::lang::IllegalArgumentException,
|  | ::com::sun::star::io::IOException,
|  | ::com::sun::star::embed::StorageWrappedTargetException
| ) |  |

allows to get access to a child storage.

The opened substorage must support specified in "nOpenMode" access modes. It can support "read" mode in addition. But any child element can support one of those modes only in case this mode is supported by parent storage.

Parameters

  sStorName | the name of the storage that should be open
  nOpenMode | a mode the storage should be open in

Exceptions

  com::sun::star::embed::InvalidStorageException | this storage is in invalid state for any reason
  com::sun::star::lang::IllegalArgumentException | one of provided arguments is illegal
  com::sun::star::io::IOException | in case of io errors during stream opening
  com::sun::star::embed::StorageWrappedTargetException | wraps other exceptions

## ◆ openStreamElement()

::com::sun::star::io::XStream openStreamElement | ( | [in] string | sStreamName,
|  | [in] long | nOpenMode
| ) |  |
raises | ( | ::com::sun::star::embed::InvalidStorageException,
|  | ::com::sun::star::lang::IllegalArgumentException,
|  | ::com::sun::star::packages::WrongPasswordException,
|  | ::com::sun::star::io::IOException,
|  | ::com::sun::star::embed::StorageWrappedTargetException
| ) |  |

allows to get access to a child stream of the storage.

In case the stream is open in readonly mode the com::sun::star::io::XStream::getOutputStream() method will return an empty reference.

Parameters

  sStreamName | the name of the substream that should be open
  nOpenMode | a mode the stream should be open in, can be a combination of ElementModes values

Exceptions

  com::sun::star::embed::InvalidStorageException | this storage is in invalid state for any reason
  com::sun::star::lang::IllegalArgumentException | one of provided arguments is illegal
  com::sun::star::packages::WrongPasswordException | the provided password is wrong
  com::sun::star::io::IOException | in case of io errors during stream opening
  com::sun::star::embed::StorageWrappedTargetException | wraps other exceptions

## ◆ removeElement()

void removeElement | ( | [in] string | sElementName | ) |
raises | ( | ::com::sun::star::embed::InvalidStorageException,
|  | ::com::sun::star::lang::IllegalArgumentException,
|  | ::com::sun::star::container::NoSuchElementException,
|  | ::com::sun::star::io::IOException,
|  | ::com::sun::star::embed::StorageWrappedTargetException
| ) |  |

removes an element from a storage.

Parameters

  sElementName | the name of the element to remove

Exceptions

  com::sun::star::embed::InvalidStorageException | this storage is in invalid state for any reason
  com::sun::star::lang::IllegalArgumentException | an illegal argument is provided
  com::sun::star::container::NoSuchElementException | there is no element with such name
  com::sun::star::io::IOException | in case of io errors during removing
  com::sun::star::embed::StorageWrappedTargetException | wraps other exceptions

## ◆ renameElement()

void renameElement | ( | [in] string | sElementName,
|  | [in] string | sNewName
| ) |  |
raises | ( | ::com::sun::star::embed::InvalidStorageException,
|  | ::com::sun::star::lang::IllegalArgumentException,
|  | ::com::sun::star::container::NoSuchElementException,
|  | ::com::sun::star::container::ElementExistException,
|  | ::com::sun::star::io::IOException,
|  | ::com::sun::star::embed::StorageWrappedTargetException
| ) |  |

renames an element in a storage.

Parameters

  sElementName | the old name of the element to rename
  sNewName | the new name of the element to rename

Exceptions

  com::sun::star::embed::InvalidStorageException | this storage is in invalid state for any reason
  com::sun::star::lang::IllegalArgumentException | an illegal argument is provided
  com::sun::star::container::NoSuchElementException | there is no element with old name in this storage
  com::sun::star::container::ElementExistException | an element with new name already exists in this storage
  com::sun::star::io::IOException | in case of io errors during renaming
  com::sun::star::embed::StorageWrappedTargetException | wraps other exceptions

The documentation for this interface was generated from the following file:

- com/sun/star/embed/XStorage.idl